from django.db import models

# Create your models here.
class login_category(models.Model):
    id = models.BigAutoField(primary_key=True)
    status=models.CharField(max_length=64)
    name=models.CharField(max_length=64)
    details=models.CharField(max_length=254, default="")

    def __str__(self):
        return self.id

class users(models.Model):
    id = models.BigAutoField(primary_key=True)
    #company= models.ForeignKey(company, on_delete=models.CASCADE, default="")
    first_name=models.CharField(max_length=32)
    middle_name=models.CharField(max_length=32)
    last_name=models.CharField(max_length=32)
    status=models.CharField(max_length=32)
    gender=models.CharField(max_length=16)
    mobile_number=models.CharField(max_length=16)
    user_email=models.EmailField(max_length=128)
    date_of_birth=models.DateTimeField()

    def __str__(self):
        return str(self.id)

class user_password(models.Model):
    id = models.BigAutoField(primary_key=True)
    users_id=models.ForeignKey(users, on_delete=models.CASCADE)
    status=models.CharField(max_length=64)
    password=models.CharField(max_length=256,)
    issue_date=models.DateTimeField(max_length=32, null=True)
    expire_date=models.DateTimeField(max_length=32,  null=True)

    def __str__(self):
        return self.id
###user_login_category ###user_login_category
class user_login_category(models.Model):
    id = models.BigAutoField(primary_key=True)
    users_id=models.ForeignKey(users, on_delete=models.CASCADE)
    login_category_id=models.ForeignKey(login_category, on_delete=models.CASCADE)
    status=models.CharField(max_length=64)

    def __str__(self):
        return self.id
    


class weight_class(models.Model):
    id = models.BigAutoField(primary_key=True)
    name=models.CharField(max_length=64)
    status=models.CharField(max_length=32)
    creation_date=models.DateTimeField(max_length=32, null=True)
    def __str__(self):
        return str(self.id)


class tax_source(models.Model):
    id = models.BigAutoField(primary_key=True)
    weight_class=models.ForeignKey(weight_class, on_delete=models.CASCADE, default=1)
    name=models.CharField(max_length=64)
    amount=models.DecimalField(max_digits=15, decimal_places=3)
    weight_measure=models.CharField(max_length=32)
    details=models.CharField(max_length=64)
    status=models.CharField(max_length=32)
    creation_date=models.DateTimeField(max_length=32, null=True)
    def __str__(self):
        return str(self.id)


class tax_source(models.Model):
    id = models.BigAutoField(primary_key=True)
    weight_class=models.ForeignKey(weight_class, on_delete=models.CASCADE, default=1)
    name=models.CharField(max_length=64)
    amount=models.DecimalField(max_digits=15, decimal_places=3)
    weight_measure=models.CharField(max_length=32)
    details=models.CharField(max_length=64)
    status=models.CharField(max_length=32)
    creation_date=models.DateTimeField(max_length=32, null=True)
    def __str__(self):
        return str(self.id)

class tax_payment(models.Model):
    id = models.BigAutoField(primary_key=True)
    tax_source=models.ForeignKey(tax_source, on_delete=models.CASCADE, default=1)
    users=models.ForeignKey(users, on_delete=models.CASCADE, default=1)
    name_of_payer=models.CharField(max_length=64)
    amount_paid=models.DecimalField(max_digits=15, decimal_places=3)
    weight_units=models.CharField(max_length=32)
    status=models.CharField(max_length=32)
    creation_date=models.DateTimeField(max_length=32, null=True)
    def __str__(self):
        return str(self.id)


class view_v_user_details_1_a(models.Model):
    users_id = models.BigAutoField(primary_key=True)
    first_name= models.CharField(max_length=32)
    middle_name= models.CharField(max_length=32)
    last_name= models.CharField(max_length=32)
    full_name= models.CharField(max_length=64)
    gender= models.CharField(max_length=16)
    mobile_number= models.CharField(max_length=16)
    user_email= models.CharField(max_length=32)
    date_of_birth=models.DateTimeField(max_length=32, null=True)
    password_id= models.IntegerField()
    user_password=models.CharField(max_length=128)
    login_category_id= models.IntegerField()
    login_category_name=models.CharField(max_length=32)
    class Meta:
        managed = False
        db_table = "v_user_details_1_a"



