"""health_clinic_is_01 URL Configuration

The `urlpatterns` list routes URLs to views. For more information please see:
    https://docs.djangoproject.com/en/4.0/topics/http/urls/
Examples:
Function views
    1. Add an import:  from my_app import views
    2. Add a URL to urlpatterns:  path('', views.home, name='home')
Class-based views
    1. Add an import:  from other_app.views import Home
    2. Add a URL to urlpatterns:  path('', Home.as_view(), name='home')
Including another URLconf
    1. Import the include() function: from django.urls import include, path
    2. Add a URL to urlpatterns:  path('blog/', include('blog.urls'))
"""
from django.urls import path
from tax.views import (
usersView, CreateUsersView, loginCategoryView, CreateUserLoginCategoryView,
CreateUserPasswordView, WeightClassView, CreateTaxSourceView,
TaxSourceView, TaxPaymentView, CreateTaxPaymentView, 
UsersDetailsView, UpdateUserPasswordView,
)

urlpatterns = [
    #path('api/home', driverView.as_view()), UsersDetailsView
    
    path('tax/usersViewEXT', usersView.as_view()),
    path('tax/usersDetailsViewEXT', UsersDetailsView.as_view()),
    path('tax/createUsersViewEXT', CreateUsersView.as_view()),
    path('tax/loginCategoryViewEXT', loginCategoryView.as_view()),
    path('tax/createUserLoginCategoryViewEXT', CreateUserLoginCategoryView.as_view()),
    path('tax/createUserPasswordViewEXT', CreateUserPasswordView.as_view()),
    path('tax/weightClassViewEXT', WeightClassView.as_view()),
    path('tax/createTaxSourceViewEXT', CreateTaxSourceView.as_view()),
    path('tax/taxSourceViewEXT', TaxSourceView.as_view()),
    path('tax/createTaxPaymentViewEXT', CreateTaxPaymentView.as_view()),
    path('tax/taxPaymentViewEXT', TaxPaymentView.as_view()),
    path('tax/updateUserPasswordViewEXT', UpdateUserPasswordView.as_view()),
    ###  UpdateUserPasswordView
    #path('api/smsGenerator/createSMSViewV,', createSMSViewV.as_view(), name="createSMSViewV"),  TaxSourceView
    ###CreateUserPasswordView   WeightClassView
    ##newEntryTokenView
]
