from django.shortcuts import render
from django.shortcuts import render
from django.http import HttpResponse
from rest_framework import generics,status
from rest_framework.views import APIView
from rest_framework.response import Response


from tax.serializers import (
UsersSerializer, CreateUsersSerializer,
LoginCategorySerializer, CreateUserLoginCategorySerializer,
CreateUserPasswordSerializer, WeightClassSerializer,
CreateTaxSourceSerializer, TaxSourceSerializer,
TaxPaymentSerializer, CreateTaxPaymentSerializer, 
UsersDetailsSerializer, UsersDetailsSerializer,
UpdateUserPasswordSerializer, DeleteUserPasswordSerializer, 
UpdateUserSingleDetailSerializer,
UpdateWeightClassSerializer,
UpdateTaxSourceSingleDetailSerializer,
 )
from tax.models import (
users, login_category, user_login_category, user_password,
weight_class, tax_source, tax_payment,
view_v_user_details_1_a,
)

from tax.general.general import general
from tax.users.users import users
from tax.taxclass.taxclass import taxclass

newGeneral=general()
newUser=users()
newTaxClass=taxclass()


class usersView(APIView):
      def get(self, request, format=None):
        try:
            queryset=users.objects.values('id', 'first_name',
             'middle_name',
             'last_name',
             'status',
             'gender',
             'mobile_number',
             'user_email',
             'date_of_birth')
            print("queryset=" + str(queryset))
            serializer_class= UsersSerializer
            serializer=UsersSerializer(users,many=True)
            
        except Exception as e:
                    print("except=" + str(e))
        return Response(queryset)



class UsersDetailsView(APIView):
      def get(self, request, format=None):
        try:
            queryset=view_v_user_details_1_a.objects.values(
             'users_id',#
             'first_name',#
                'middle_name',#
                'last_name',#
                'full_name',#
                'gender',#
                'mobile_number',#
                'user_email',#
                'date_of_birth',#
                'password_id',#
                'user_password',#
                'login_category_id',#
                'login_category_name',#
             )
            print("queryset=" + str(queryset))
            serializer_class= UsersDetailsSerializer
            serializer=UsersDetailsSerializer(view_v_user_details_1_a,many=True)
            
        except Exception as e:
                    print("except=" + str(e))
        return Response(queryset)


class CreateUsersView(APIView):
    serializer_class= CreateUsersSerializer
    def post(self, request, format=None):
        serializer= self.serializer_class(data=request.data)
        print("data=" + str(request.data))
        idx=0
        msg=""
        try:
            print("123")
            firstName=request.data['first_name']
            print("123=" + str(request.data['first_name']))
            middleName=request.data['middle_name']
            print("123=" + str(request.data['middle_name']))
            lastName=request.data['last_name']
            print("123=" + str(request.data['last_name']))
            gender=request.data['gender']
            print("123=" + str(request.data['gender']))
            mobileNumber=request.data['mobile_number']
            print("123=" + str(request.data['mobile_number']))
            userEmail=request.data['user_email']
            print("123=" + str(request.data['user_email']))
            dateOfBirth=request.data['date_of_birth']
            print("123=" + str(request.data['date_of_birth']))
            status_=request.data['status']
            print("123=" + str(request.data['status']))
            print("456")  
            inv=users(first_name= firstName, middle_name= middleName, last_name= lastName, status=status_, gender=gender, mobile_number=mobileNumber, user_email=userEmail, date_of_birth=dateOfBirth)
            inv.save()

            ixc=users.objects.values().filter(mobile_number=mobileNumber, 
            first_name=firstName, middle_name=middleName, last_name=lastName)
            for ab in ixc:
                    idx=ab['id']

            print ("name=" + str(users))
            msg="User registration was successful"
            """     
            if serializer.is_valid():
                firstName=serializer.data['first_name']
                middleName=serializer.data['middle_name']
                lastName=serializer.data['last_name']
                gender=serializer.data['gender']
                mobileNumber=serializer.data['mobile_number']
                userEmail=serializer.data['user_email']
                dateOfBirth=serializer.data['date_of_birth']
                status_=serializer.data['status']
                
                inv=users(
                    first_name= firstName,
                    middle_name= middleName,
                    last_name= lastName,
                    status=status_,
                    gender=gender,
                    mobile_number=mobileNumber,
                    user_email=userEmail,
                    date_of_birth=dateOfBirth
                    )
                inv.save()

                ixc=users.objects.values().filter(mobile_number=mobileNumber, 
                first_name=firstName, middle_name=middleName, last_name=lastName)
                for ab in ixc:
                     idx=ab['id']

                print ("name=" + str(users))
                msg="User registration was successful"
                
            else:
                msg="serializer failed"
                print ("error=" + "serializer failed")
                inv=users(
                    first_name= '', middle_name= '', last_name= '', status= '', gender= '', mobile_number= '',
                    user_email= '',date_of_birth=''
                )
                idx=0 """
        except Exception as e:
                print("except=" + str(e))
                msg=str(e)
        #return Response('', status=status.HTTP_201_CREATED)
        #return Response(CreateUsersSerializer(inv).data, status=status.HTTP_201_CREATED)
        print("user_id=" + str(idx) + ", " +  str(""))
        return Response({'user_id': idx, 'status': str(status.HTTP_201_CREATED), 'msg': msg})


class UpdateUserSingleDetailView(APIView):
    serializer_class= UpdateUserSingleDetailSerializer
    def post(self, request, format=None):
        serializer= self.serializer_class(data=request.data)
        print("data=" + str(request.data))
        idx=0
        msg=""
        try:
            usersId=request.data['users_id_id']
            fieldToUpdate=request.data['first_name']
            valueToUpdate=request.data['status']
            newUser.UpdateUserSingleDetail(self, usersId, fieldToUpdate, valueToUpdate)
            
            msg= fieldToUpdate + " was successfully updated"
                 
            """ 
            if serializer.is_valid():
                
            """
        except Exception as e:
                print("except=" + str(e))
                msg=str(e)
        #return Response('', status=status.HTTP_201_CREATED)
        #return Response(CreateUsersSerializer(inv).data, status=status.HTTP_201_CREATED)
        #print("user_id=" + str(idx) + ", " +  str(""))
        return Response({'user_id': idx, 'status': str(status.HTTP_201_CREATED), 'msg': msg})


class loginCategoryView(APIView):
      def get(self, request, format=None):
        try:
            queryset=login_category.objects.values('id','name',
             'status',
             'details')
            print("queryset:::=" + str(queryset))
            serializer_class= LoginCategorySerializer
            serializer=LoginCategorySerializer(users,many=True)
            
        except Exception as e:
                    print("except=" + str(e))
        return Response(queryset)


class WeightClassView(APIView):
      def get(self, request, format=None):
        try:
            queryset=weight_class.objects.values('id', 'name', 'status', 'creation_date')
            print("queryset:::=" + str(queryset))
            serializer_class= WeightClassSerializer
            serializer=WeightClassSerializer(weight_class,many=True)
            
        except Exception as e:
                    print("except=" + str(e))
        return Response(queryset)
      


class UpdateWeightClassView(APIView):
    serializer_class= UpdateWeightClassSerializer
    def post(self, request, format=None):
        serializer= self.serializer_class(data=request.data)
        print("data=" + str(request.data))
        idx=0
        msg=""
        try:
            weightClassId=request.data['weight_class_id']
            weightClassName=request.data['name']
            
            newTaxClass.updateWeightClass( weightClassId, weightClassName)
            
            msg= "Weight class was successfully updated"
                 
            """ 
            if serializer.is_valid():
                
            """
        except Exception as e:
                print("except=" + str(e))
                msg=str(e)
        #return Response('', status=status.HTTP_201_CREATED)
        #return Response(CreateUsersSerializer(inv).data, status=status.HTTP_201_CREATED)
        #print("user_id=" + str(idx) + ", " +  str(""))
        return Response({'user_id': idx, 'status': str(status.HTTP_201_CREATED), 'msg': msg})



class UpdateTaxSourceSingleDetailView(APIView):
    serializer_class= UpdateTaxSourceSingleDetailSerializer
    def post(self, request, format=None):
        serializer= self.serializer_class(data=request.data)
        print("data=" + str(request.data))
        idx=0
        msg=""
        try:
            taxSourceId=request.data['id']
            fieldToUpdate=request.data['name']
            valueToUpdate=request.data['status']
            
            newTaxClass.UpdateTaxSourceSingleDetail( taxSourceId, fieldToUpdate, valueToUpdate)
            
            msg= "Tax source was successfully updated"
                 
            """ 
            if serializer.is_valid():
                
            """
        except Exception as e:
                print("except=" + str(e))
                msg=str(e)
        #return Response('', status=status.HTTP_201_CREATED)
        #return Response(CreateUsersSerializer(inv).data, status=status.HTTP_201_CREATED)
        #print("user_id=" + str(idx) + ", " +  str(""))
        return Response({'user_id': idx, 'status': str(status.HTTP_201_CREATED), 'msg': msg})



""" 
class WeightClassView(APIView):
      def get(self, request, format=None):
        try:
            queryset=weight_class.objects.values('id', 'name', 'status', 'creation_date')
            print("queryset:::=" + str(queryset))
            serializer_class= WeightClassSerializer
            serializer=WeightClassSerializer(weight_class,many=True)
            
        except Exception as e:
                    print("except=" + str(e))
        return Response(queryset)
 """
class TaxSourceView(APIView):
      def get(self, request, format=None):
        try:
            queryset=tax_source.objects.values()#'id', 'name', 'status', 'creation_date')
            print("queryset:::=" + str(queryset))
            serializer_class= TaxSourceSerializer
            serializer=TaxSourceSerializer(weight_class,many=True)
            
        except Exception as e:
                    print("except=" + str(e))
        return Response(queryset)



class TaxPaymentView(APIView):
      def get(self, request, format=None):
        try:
            queryset=tax_payment.objects.values()#'id', 'name', 'status', 'creation_date')
            print("queryset:::=" + str(queryset))
            serializer_class= TaxPaymentSerializer
            serializer=TaxPaymentSerializer(tax_payment,many=True)
            
        except Exception as e:
                    print("except=" + str(e))
        return Response(queryset)




class CreateUserLoginCategoryView(APIView):
    serializer_class= CreateUserLoginCategorySerializer
    def post(self, request, format=None):
        serializer= self.serializer_class(data=request.data)
        print("data=" + str(request.data))

        #print("data ['users_id_id']=" + str(request.data['users_id_id']))
        #print("data ['login_category_id_id']=" + str(request.data['login_category_id_id']))
        #print("data ['status]=" + str(request.data['status']))

        #print("serializer.validated_data=" + str(serializer.validated_data))
        usersIdId=0
        msg=""
        responseStatus=""
        resp=""#{'user_id': usersIdId, 'msg': msg, 'status': str(responseStatus)}
        try:
            usersIdId=request.data['users_id_id']
            loginCategoryIdId=request.data['login_category_id_id']
            status=request.data['status']
                 
            print("'" + str(usersIdId) + "', " + "'" + str(loginCategoryIdId) + "', " + "'" + status + "', " )
                 
            inv=user_login_category(
                     users_id_id= usersIdId,
                     login_category_id_id= loginCategoryIdId,
                    status=status
                    )
            #print ("inv.data()=" + str(inv.data()))
            inv.save()
            # if serializer.is_valid():
            #     print("serializer.data=" + str(serializer.validated_data))
            #     serializer.save()
            #     resp={'msg': msg, 'status': str(status.HTTP_201_CREATED)}
            #     #return Response(serializer.data,status=status.HTTP_201_CREATED)

            # else:
            #     print('error',serializer.errors)
            #     resp={ 'msg': msg, 'status': str(status.HTTP_400_BAD_REQUEST)}
            #     #return Response(serializer.errors,status=status.HTTP_400_BAD_REQUEST)

            """ if serializer.is_valid():
                 #print("'" + str(serializer.data['users_id_id']) + "', " + "'" + str(serializer.data['login_category_id_id']) + "', " + "'" + str(serializer.data['status']) + "', " )
                  
                 usersIdId=serializer.data['users_id_id']
                 loginCategoryIdId=serializer.data['login_category_id_id']
                 status=serializer.data['status']
                 
                 print("'" + str(usersIdId) + "', " + "'" + str(loginCategoryIdId) + "', " + "'" + status + "', " )
                 
                 inv=user_login_category(
                     users_id_id= usersIdId,
                     login_category_id_id= loginCategoryIdId,
                    status=status
                    )
                 #print ("inv.data()=" + str(inv.data()))
                 inv.save()
                 #print ("inv.data()=" + str(inv.data()))
                 msg="Category creating was successful"
            #     responseStatus="" + str(status.HTTP_201_CREATED)
            else:
                 print('error',serializer.errors)
                 print ("error=" + "serializer failed")
                 inv=user_login_category(
                     users_id_id= '', login_category_id_id= '', status= ''
                 )
                 msg="Category creating was not successful" """
            #     responseStatus="fail" #+ str(status.HTTP_)
        except Exception as e:
                print("except=" + str(e))
                msg="" + str(e)
        #resp={'user_id': usersIdId, 'msg': msg, 'status': str(responseStatus)}
        #return Response('', status=status.HTTP_201_CREATED)
        return Response(resp)
    



class CreateUserPasswordView(APIView):
    serializer_class= CreateUserPasswordSerializer
    def post(self, request, format=None):
        serializer= self.serializer_class(data=request.data)
        print("data=" + str(request.data))
        idx=0
        msg=""
        try:
            userPassword=request.data['password']
            issueDate=request.data['issue_date']
            expireDate=request.data['expire_date']
            usersIdId=request.data['users_id_id']
            status=request.data['status']
                
            inv=user_password(
                    password= userPassword,
                    issue_date=expireDate,
                    expire_date= expireDate,
                    status=status,
                    users_id_id=usersIdId
                    )
            inv.save()
            
                
            msg="Password registration was successful"
            """ 
            if serializer.is_valid():
                userPassword=serializer.data['password']
                issueDate=serializer.data['issue_date']
                expireDate=serializer.data['expire_date']
                usersIdId=serializer.data['users_id_id']
                status=serializer.data['status']
                
                inv=users(
                    password= userPassword,
                    issue_date=expireDate,
                    expire_date= expireDate,
                    status=status,
                    users_id_id=usersIdId
                    )
                inv.save()

                
                msg="Password registration was successful"
                
            else:
                msg="serializer failed"
                print ("error=" + "serializer failed")
                inv=users(
                    password= '',
                    issue_date= '',
                    expire_date= '',
                    status='',
                    users_id_id=''
                    )
                inv.save()
                idx=0 """
        except Exception as e:
                print("except=" + str(e))
                msg=str(e)
        #return Response('', status=status.HTTP_201_CREATED)
        #return Response(CreateUsersSerializer(inv).data, status=status.HTTP_201_CREATED)
        #print("user_id=" + str(idx) + ", " +  str(""))
        return Response({'user_id': idx, 'status': str(""), 'msg': msg})


class UpdateUserPasswordView(APIView):
    serializer_class= UpdateUserPasswordSerializer
    def post(self, request, format=None):
        serializer= self.serializer_class(data=request.data)
        print("data=" + str(request.data))
        idx=0
        msg=""
        try:
            newPassword=request.data['password']
            usersId=request.data['users_id_id']
            oldPassword=request.data['status']
            numberDays=180
            newDateAfterSixMonths=newGeneral.getDateAfterDays(numberDays)   
            expireDateStr=newGeneral.convertDateToYMD(newDateAfterSixMonths)
            issueDateStr=newGeneral.getTodayDate() + ' ' + newGeneral.getTodayTime()
            passwordExists=False
            passwordExists=newUser.updatePassword( usersId, oldPassword, newPassword, issueDateStr, expireDateStr)
            
            if passwordExists==False:     
                msg="Password updating was not successful"
            else:
                 msg="Password updating was successful"
                 
            """ 
            if serializer.is_valid():
                
            """
        except Exception as e:
                print("except=" + str(e))
                msg=str(e)
        #return Response('', status=status.HTTP_201_CREATED)
        #return Response(CreateUsersSerializer(inv).data, status=status.HTTP_201_CREATED)
        #print("user_id=" + str(idx) + ", " +  str(""))
        return Response({'user_id': idx, 'status': str(""), 'msg': msg})



class DeleteUserPasswordView(APIView):
    serializer_class= DeleteUserPasswordSerializer
    def post(self, request, format=None):
        serializer= self.serializer_class(data=request.data)
        print("data=" + str(request.data))
        idx=0
        msg=""
        try:
            usersId=request.data['users_id_id']
            
            newUser.deleteUserPassword(self, usersId)
            
            msg="Password was successfully deleted"
                 
            """ 
            if serializer.is_valid():
                
            """
        except Exception as e:
                print("except=" + str(e))
                msg=str(e)
        #return Response('', status=status.HTTP_201_CREATED)
        #return Response(CreateUsersSerializer(inv).data, status=status.HTTP_201_CREATED)
        #print("user_id=" + str(idx) + ", " +  str(""))
        return Response({'user_id': idx, 'status': str(""), 'msg': msg})

class CreateTaxSourceView(APIView):
    serializer_class= CreateTaxSourceSerializer
    def post(self, request, format=None):
        serializer= self.serializer_class(data=request.data)
        print("data=" + str(request.data))
        idx=0
        msg=""
        try:
            taxSourceName=request.data['name']
            taxSourceAmount=request.data['amount']
            weightMeasure=request.data['weight_measure']
            details=request.data['details']
            creationDate=request.data['creation_date']
            status_=request.data['status']
                
            inv=tax_source(
                    name= taxSourceName,
                    amount= taxSourceAmount,
                    weight_measure= weightMeasure,
                    status=status_,
                    details=details,
                    creation_date=creationDate,
                    )
            inv.save()

               
            print ("name=" + str(tax_source))
            msg="Tax source was successful"
                
            """ if serializer.is_valid():
                taxSourceName=serializer.data['name']
                taxSourceAmount=serializer.data['amount']
                weightMeasure=serializer.data['weight_measure']
                details=serializer.data['details']
                creationDate=serializer.data['creation_date']
                status_=serializer.data['status']
                
                inv=tax_source(
                    name= taxSourceName,
                    amount= taxSourceAmount,
                    weight_measure= weightMeasure,
                    status=status_,
                    details=details,
                    creation_date=creationDate,
                    )
                inv.save()

               
                print ("name=" + str(tax_source))
                msg="Tax source was successful"
                
            else:
                msg="serializer failed"
                print ("error=" + "serializer failed")
                inv=tax_source(
                    name= '', amount= '', weight_measure= '',
                    status='', details='', creation_date='',
                )
                idx=0 """
        except Exception as e:
                print("except=" + str(e))
                msg=str(e)
        #return Response('', status=status.HTTP_201_CREATED)
        #return Response(CreateUsersSerializer(inv).data, status=status.HTTP_201_CREATED)
        print("tax_source_id=" + str(idx) + ", " +  str(""))
        return Response({'tax_source_id': idx, 'status': str(status.HTTP_201_CREATED), 'msg': msg})



class CreateTaxPaymentView(APIView):
    serializer_class= CreateTaxPaymentSerializer
    def post(self, request, format=None):
        serializer= self.serializer_class(data=request.data)
        print("data=" + str(request.data))
        idx=0
        msg=""
        try:
            '''
            amount_paid=models.DecimalField(max_digits=15, decimal_places=3)
            '''
            taxSourceId=request.data['tax_source_id']
            usersId=request.data['users_id']
            nameOfPayer=request.data['name_of_payer']
            amountPaid=request.data['amount_paid']
            weightUnits=request.data['weight_units']
            creationDate=request.data['creation_date']
            status_=request.data['status']  

            inv=tax_payment(
                    tax_source_id= taxSourceId,
                    users_id= usersId,
                    name_of_payer= nameOfPayer,
                    amount_paid=amountPaid,
                    weight_units=weightUnits,
                    status=status_,
                    creation_date=creationDate,
                    )
            inv.save()

            idx=0  
            msg="Tax payment was successful"
                
            """ if serializer.is_valid():
                taxSourceName=serializer.data['name']
                taxSourceAmount=serializer.data['amount']
                weightMeasure=serializer.data['weight_measure']
                details=serializer.data['details']
                creationDate=serializer.data['creation_date']
                status_=serializer.data['status']
                
                inv=tax_source(
                    name= taxSourceName,
                    amount= taxSourceAmount,
                    weight_measure= weightMeasure,
                    status=status_,
                    details=details,
                    creation_date=creationDate,
                    )
                inv.save()

               
                print ("name=" + str(tax_source))
                msg="Tax source was successful"
                
            else:
                msg="serializer failed"
                print ("error=" + "serializer failed")
                inv=tax_source(
                    name= '', amount= '', weight_measure= '',
                    status='', details='', creation_date='',
                )
                idx=0 """
        except Exception as e:
                print("except=" + str(e))
                msg=str(e)
        #return Response('', status=status.HTTP_201_CREATED)
        #return Response(CreateUsersSerializer(inv).data, status=status.HTTP_201_CREATED)
        print("tax_source_id=" + str(idx) + ", " +  str(""))
        return Response({'tax_payment_id': idx, 'status': str(status.HTTP_201_CREATED), 'msg': msg})





