from django.shortcuts import render
from django.http import HttpResponse
from rest_framework import generics,status
from rest_framework.views import APIView
from rest_framework.response import Response
from api.serializers import (
DriverSerializer,getAllDriversSerializer,
 CreatePatientSerializer,newEntryTokenSerializer,
 driverNewEntrySerializer,
 )
from cards_ms.models import (
drivers,driver_entry,entry_token,driver_entry_points,
driver_entry_msg,points_details,
)
#from api.validations import validationsC
# Create your views here.


#class patientView(generics.ListAPIView):
#class patientView(generics.CreateAPIVie
class driverView(generics.ListAPIView):
    queryset=drivers.objects.all()
    serializer_class= DriverSerializer

class getAllDriversView(APIView):
    serializer_class= getAllDriversSerializer
    def get(self, request, format=None):
        inv=drivers.objects.all()
        #return Response('', status=status.HTTP_201_CREATED)
        return Response(getAllDriversSerializer(inv).data, status=status.HTTP_201_CREATED)



class CreatePatientView(APIView):
    serializer_class= CreatePatientSerializer
    def post(self, request, format=None):
        serializer= self.serializer_class(data=request.data)
        print("data=" + str(request.data))
        if serializer.is_valid():
            name_=serializer.data['name']
            dob_=serializer.data['dob']
            address_=serializer.data['address']
            telephone_=serializer.data['telephone']
            inv=drivers(name=name_,dob=dob_,address=address_,telephone=telephone_)
            inv.save()
            print ("name=" + str(name_))
        else:
            inv=drivers(name='',dob='',address='',telephone='')

        #return Response('', status=status.HTTP_201_CREATED)
        return Response(DriverSerializer(inv).data, status=status.HTTP_201_CREATED)

###driverNewEntrySerializer

class driverNewEntryView(APIView):
    serializer_class= driverNewEntrySerializer
    #newV=validationsC()
    x=0
    y=0
    def post(self, request, format=None):
        serializer= self.serializer_class(data=request.data)
        print("data=" + str(request.data))
        if serializer.is_valid():
            x=1
            entryId=0
            #x=newV.lookIfDriverEntryExists(serializer.data['entry_time'], serializer.data['drivers_id_id'])
            if x>0:
                drivers_id_=serializer.data['drivers_id']
                entry_time_=serializer.data['entry_time']
                inv=driver_entry(drivers_id=drivers.objects.get(drivers_id=drivers_id_),
                entry_time=entry_time_)
                inv.save()
                entryId=self.getEntryId(entry_time_,drivers_id_)
                self.saveEntryMsg(entryId)
                (a,b)=self.getEntryPointsAndAmount()
                self.saveEntryPoints(entryId,a,b)
            ###print ("name=" + str(name_))
        else:
            print(serializer.errors)
            #inv=driver_entry(drivers_id_id=0,entry_time='',driver_entry_id=0)
            inv=driver_entry()

        #return Response('', status=status.HTTP_201_CREATED)
        return Response(driverNewEntrySerializer(inv).data, status=status.HTTP_201_CREATED)

    def getEntryId(self,entryTime,driversId):
        inv=driver_entry.objects.values().filter(entry_time=entryTime,drivers_id_id=driversId)
        x=list(inv)
        y=0

        if len(x)>0:
            y=x[0]['driver_entry_id']
        else:
            y=y
        return y

    def saveEntryMsg(self,entryId):
        inv=driver_entry_msg(driver_entry_id_id=entryId,entry_msg_id_id=1,status='Not Sent')
        inv.save()

    def getEntryPointsAndAmount(self):
        inv=points_details.objects.values().filter(status='Active')
        x=list(inv)
        y=0.0
        z=0
        #m=(,)
        m=0
        if len(x)>0:
            y=x[0]['amount']
            z=x[0]['points']
            m=(z,y)
        else:
            m=(0,0)
        return m

    def saveEntryMsg(self,entryId):
        inv=driver_entry_msg(driver_entry_id_id=entryId,entry_msg_id_id=1,status='Not Sent')
        inv.save()

    def saveEntryPoints(self,entryId,points,amount):
        inv=driver_entry_points(driver_entry_id_id=entryId,points=points,amount=amount,status='Entry')
        inv.save()



class newEntryTokenView(APIView):
    serializer_class= newEntryTokenSerializer
    #newV=validationsC()
    x=0
    def post(self, request, format=None):
        serializer= self.serializer_class(data=request.data)
        print("data=" + str(request.data))
        if serializer.is_valid():
            x=1
            #x=newV.lookIfDriverEntryExists(serializer.data['entry_time'], serializer.data['drivers_id_id'])
            if x>0:
                token_date_=serializer.data['token_date']
                entry_token_no_=serializer.data['entry_token_no']
                drivers_id_=serializer.data['drivers_id']
                inv=entry_token(drivers_id=drivers.objects.get(drivers_id=drivers_id_),
                token_date=token_date_,entry_token_no=entry_token_no_)
                inv.save()
            ###print ("name=" + str(name_))
        else:
            print(serializer.errors)
            #inv=driver_entry(drivers_id_id=0,entry_time='',driver_entry_id=0)
            inv=entry_token()
        #return Response('', status=status.HTTP_201_CREATED)
        return Response(newEntryTokenSerializer(inv).data, status=status.HTTP_201_CREATED)
